/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package WebService;

import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 *
 * @author villeche
 */


public class BierwithVector implements Cloneable
{
    
    public int[] vector;
    public int nbJobs;
    public int nbMach;
    public int nbOps;
    
    public BierwithVector()
    {
        nbJobs = 0;
        nbMach = 0;
        nbOps = 0;
        vector = null;
    }
    
    public BierwithVector(int nbJobs, int nbMach, long seed)
    {
        //PARAMETRE
        int nbPermutations = nbJobs * nbMach * 10;
        
        this.nbJobs = nbJobs;
        this.nbMach = nbMach;
        this.nbOps = nbJobs*nbMach;
        vector = new int[nbOps];
        int ind = 0;
        int i = 0;
        int j = 0;
        int p1 = 0;
        int p2 = 0;
        int tmp;

        Random r;
        if (seed == -1)
        {
            r = new Random();
        }
        else
        {
            r = new Random(seed);
        }

        //g�n�ration vecteur de Bierwith
        //cette boucle g�n�re le vecteur 1,2,3,4,1,2,3,4,1,2,3,4
        for (i = 1 ; i <= nbMach ; i++)
        {
            for (j = 1 ; j <= nbJobs ; j++)
            {
                    this.vector[ind++] = j;
            }
        }
        
        //cette boucle effectue des permutations dans le vecteur de bierwith
        for(i = 0 ; i < nbPermutations ; i++ )
        {
            //tirer p1 et p2 entre [1,taille]
            p1 = r.nextInt(nbOps);
            p2 = r.nextInt(nbOps);
            //permuter
            tmp = this.vector[p1];
           this.vector[p1] = this.vector[p2];
            this.vector[p2] = tmp;
        }
    }
    
    @Override
    public Object clone()
    {
        BierwithVector tmp = null;
        try 
        {
            tmp = (BierwithVector) super.clone();
            tmp.nbJobs = this.nbJobs;
            tmp.nbMach = this.nbMach;
            tmp.nbOps = this.nbOps;
            tmp.vector = (int[]) this.vector.clone();
        } 
        catch (CloneNotSupportedException ex) 
        {
            Logger.getLogger(BierwithVector.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return tmp;
    }
}
