/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package WebService;

import java.io.*;
import java.util.Scanner;
import java.util.UUID;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.ws.Holder;

/**
 *
 * @author villeche
 */
public class Data implements Cloneable
{
    public int nbJobs;
    public int nbMach;
    public int nbOps;
    public int time[];
    public int mach[];
    public int job[];
    public int lowerBound;
    
    public Data()
    {
        nbJobs = 0;
        nbMach = 0;
        nbOps = 0;
        lowerBound = 0;
        time = null;
        mach = null;
        job = null;
    }


    public Data(byte[] file, Holder<Integer> error, Holder<String> stringError)
    {
        String uuid = UUID.randomUUID().toString();
        File fichier = new File(WebServiceJobShop.emplacementFichiers + "instance" + uuid + ".txt");
        try
        {
            String line;
            
            InputStream ips2 = new ByteArrayInputStream(file);
            InputStreamReader ipsr2 = new InputStreamReader(ips2);
            BufferedReader br2 = new BufferedReader(ipsr2);
            FileWriter fw2 = new FileWriter(fichier, false);
            BufferedWriter output2 = new BufferedWriter(fw2);

            while( (line = br2.readLine()) != null)
            {
                output2.write(line+ System.getProperty("line.separator"));
            }
            
            output2.close();
            br2.close();
            ipsr2.close();
            ips2.close();
            fw2.close();
            
            //le fichier La.txt existe est est rempli
            Scanner lecteur = new Scanner(fichier);

            //lire le nombre de jobs et le nombre de machines 
            this.nbJobs = lecteur.nextInt();
            this.nbMach = lecteur.nextInt();
            this.lowerBound = lecteur.nextInt();
            
            this.nbOps = this.nbJobs * this.nbMach;
            
            time = new int[this.nbOps];
            mach = new int[this.nbOps];
            job = new int[this.nbOps];
            
            int jobCourant = 1;
            int i = 0;
            int j = 0;
            int pos = 0;
            int tmpMach = 0;
            for (i = 0 ; i < nbJobs ; i++)
            {
                for (j = 0 ; j < nbMach ; j++)
                {
                    job[pos] = jobCourant;
                    tmpMach = lecteur.nextInt()+1;
                    if (tmpMach> nbMach || tmpMach < 0)
                    {
                        throw new Exception();
                    }
                    else
                    {
                        mach[pos] = tmpMach;
                    }

                    time[pos] = lecteur.nextInt();
                    pos++;
                }
                ++jobCourant;                
            }
            //fermer le fichier
            lecteur.close();
            fichier.delete();  
        }
        catch (Exception e)
        {
            e.printStackTrace();
            error.value = -1;
            stringError.value = "Your file does not respect the format required";
            fichier.delete();  
        }
    }
    
    @Override
    public Object clone()
    {
        Data tmp = null;
        try 
        {
            tmp = (Data) super.clone();
            tmp.job = (int[]) this.job.clone();
            tmp.mach = (int[]) this.mach.clone();
            tmp.time = (int[]) this.time.clone();
            tmp.nbJobs = this.nbJobs;
            tmp.nbMach = this.nbMach;
            tmp.nbOps = this.nbOps;
         } 
        catch (CloneNotSupportedException ex) 
        {
            Logger.getLogger(BierwithVector.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return tmp;
    }
}
