/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package WebService;

import java.io.*;
import java.util.Date;
import java.util.Random;
import java.util.UUID;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.servlet.http.HttpServletRequest;
import javax.xml.ws.Holder;
import javax.xml.ws.WebServiceContext;
import javax.xml.ws.handler.MessageContext;

/**
 *
 * @author villeche
 */
@WebService(serviceName = "WebServiceJobShop")
@Stateless()
public class WebServiceJobShop 
{
    
    /*déclaration permettant de récupérer des informations sur le client*/
    @Resource
    WebServiceContext wsContext;

    /*déclaration de la structure Fichier*/
    class Fichier 
    { 
        public String   tag;
        public long     dateDemande;
        public int      resultat_ready;
        public int      occupe;
        public String   erreur;
        
        //data = soit result png soit bestSolution
        public Solution bestSol;
        public boolean  stop_Grasp;
    }
    
    /*déclaration des varaibles globales statiques*/
    static Fichier[][]  tableau;
    static int[]        occupe;
    static String[]     ip;
    static int[]        nbFichiers;
    
    static final int    MODULO = 10000;
    //static Random       aleatoire;
    static String       emplacementExec;
    static String       emplacementFichiers;
    static int          NBMAX_CLIENTS;
    static int          NBMAX_FICHIERS;
    static int          TPS_DE_VIE_MAX;
    //private static int  id = 0;
    /*la suite d'instruction suivante est exécutée une fois au chargement de la classe*/
    static
    {
        try 
        {
            //Lien vers fichier conf à changer
            
            File config = new File("C:\\Users\\villeche\\Documents\\NetBeansProjects\\WebServiceRO\\fichierConfiguration.conf");
            FileInputStream ips = new FileInputStream(config);
            InputStreamReader ipsr = new InputStreamReader(ips);
            BufferedReader br = new BufferedReader(ipsr);
            
            //récupération des paramètres dans le ficheir de conf
            emplacementExec = br.readLine();
            emplacementFichiers = br.readLine();
            NBMAX_CLIENTS = Integer.parseInt(br.readLine());
            NBMAX_FICHIERS = Integer.parseInt(br.readLine());
            TPS_DE_VIE_MAX = Integer.parseInt(br.readLine());
            
            //allocation des varaibles statiques
            tableau = new Fichier[NBMAX_CLIENTS][NBMAX_FICHIERS];
            occupe = new int[NBMAX_CLIENTS];
            ip = new String[NBMAX_CLIENTS];
            for (int i = 0 ; i < NBMAX_CLIENTS ; ++i)
            {
                ip[i] = " ";
            }
            nbFichiers = new int[NBMAX_CLIENTS];
            
            br.close();
            ips.close();  
        } 
        catch (Exception ex) 
        {
        
        } 
    }
    
   
    
    private int suppressionFichier(int emplacementClient)
    { 
        int retour = -1;
        int j = 0;
        boolean stop = false;
        
        long dateCourante = new Date().getTime();
        float temps;
        //si on supprime c'est que toutes les cases dispo sont occupés
        while(!stop && j < NBMAX_FICHIERS)
        {
            //recupération du temps en millisecondes
            temps = (dateCourante - tableau[emplacementClient][j].dateDemande) / (60000*1.0f);
            //transtyper en minute
            //temps = temps / 60000;
            
            if (temps > TPS_DE_VIE_MAX)
            {
                //on a trouvé un fichier à virer
                retour = j;
                nbFichiers[emplacementClient]--;
                tableau[emplacementClient][j].resultat_ready = 0;
                tableau[emplacementClient][j].stop_Grasp = false;
                tableau[emplacementClient][j].bestSol = null;
                stop = true;
            }
            j++;
        }
        
        return retour;
    }
    
    /*retourne -1 si aucun client ne peut être supprimé
     *retourne l'indice de l'emplacement dispo sinon
     */
    private int suppressionClient() 
    {
        int retour = -1;
        int i = 0, j = 0;
        boolean stop = false;
        boolean virerClienti;
        long dateCourante = new Date().getTime();
        float temps;
        while (!stop && i < NBMAX_CLIENTS)
        {
            virerClienti = true;
            j = 0;
            while(virerClienti && j < NBMAX_FICHIERS)
            {
                //si la case est occupée
                if (tableau[i][j]!=null && tableau[i][j].occupe == 1)
                {
                    //recupération du temps en millisecondes
                    temps = (dateCourante - tableau[i][j].dateDemande) / (60000 * 1.0f);
                    //transtyper en minute
                    //temps = temps / 60000;
                    //si le temps est inférieur au temps de vie max alors le client ne doit pas etre supprimé
                    if (temps < TPS_DE_VIE_MAX)
                    {
                        virerClienti = false;
                    }
                }
                
                j++;
            }
            //si on a trouvé un client à virer
            if (virerClienti)
            {
                //récuperer son indice pour le retourner
                retour = i;
                nbFichiers[i] = 0;
                j = 0;
                //pas obligatoire si géré avec NULL les fichiers
                while (j < NBMAX_FICHIERS)
                {
                    tableau[i][j].occupe = 0;
                    tableau[i][j].resultat_ready = 0;
                    tableau[i][j].stop_Grasp = false;
                    tableau[i][j].bestSol = null;
                    j++;
                }
                //dispo[i] = 0;
                ip[i] = "";
                //s'arrêter
                stop = true;
            }
            i++;
        }
        return retour;
    }
    
       
    @WebMethod(operationName = "getRandomBierwithVector")
    public BierwithVector getRandomBierwithVector(@WebParam(name = "data") Data data,@WebParam(name = "seed") long seed) 
    {
        if (data == null)
        {
            return null;
        }
        BierwithVector tmp = new BierwithVector(data.nbJobs, data.nbMach, seed);
        return tmp;
    }
    
    
    @WebMethod(operationName = "getNeighbourBierwithVector")
    public BierwithVector getNeighbourBierwithVector(@WebParam(name = "bv") BierwithVector bv) 
    {
        if (bv == null)
        {
            return null;
        }
        BierwithVector voisin = (BierwithVector) bv.clone();

        int p1 = 0;
        int p2 = 0;
        int tmp;
        int i = 0;
        Random r = new Random();

        p1 = r.nextInt(voisin.nbOps);
        do
        {
            p2 = r.nextInt(voisin.nbOps);
            i++;
        }
        while(p2==p1 && i <10);
        
        tmp = voisin.vector[p1];
        voisin.vector[p1] = voisin.vector[p2];
        voisin.vector[p2] = tmp;
        
        return voisin;
    }
    
    @WebMethod(operationName = "getData")
    public Data getData(@WebParam(name = "file") byte[] file,@WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error,@WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError) 
    {
        if (file == null)
        {
            return null;
        }
        error.value = 0;
        stringError.value = "";
        Data ret = new Data(file,error,stringError);
        if (error.value < 0)
        {
            ret = null;
        }
        return ret;
        
    }
    
    @WebMethod(operationName = "evaluate")
    public Solution evaluate(@WebParam(name = "data") Data d,@WebParam(name = "bv") BierwithVector bv) 
    {
        int i = 0;
        int j = 0;

        int nbMachine[] = new int[d.nbMach];
        int cpt[] = new int[d.nbJobs];
        int numeroOp[] = new int[d.nbOps];
        int head[] = new int[d.nbOps];
        int ordreDesOperations[][] = new int[d.nbMach][d.nbJobs];
        
        if (d==null || bv==null)
        {
            return null;
        }
        
        for (i = 0 ; i < d.nbOps ; i++)
        {
            head[i] = -1;
        }
        
        for (i = 0 ; i < d.nbOps ; i++)
        {
            numeroOp[i] = (bv.vector[i]-1)*d.nbMach+cpt[bv.vector[i]-1];
            
            ordreDesOperations[d.mach[numeroOp[i]]-1][nbMachine[d.mach[numeroOp[i]]-1]] = numeroOp[i];
            nbMachine[d.mach[numeroOp[i]]-1]++;
            cpt[bv.vector[i]-1]++;
        }

        for (i = 0 ; i < d.nbMach ; i++)
        {
            for (j = 1 ; j < d.nbJobs ; j++)
            {
                head[ordreDesOperations[i][j]] = ordreDesOperations[i][j-1];
            }
        }
        
        //en prenant les sommets dans l'ordre donne dans tableau numeroOp
        int op = 0;
        int max = -1;

        Solution sol = new Solution(bv);
        i= 0;
        op = numeroOp[i];
        sol.startDate[op] = 0;
        sol.head[op] = -1;
        for (i = 1 ; i < d.nbOps ; i++)
        {
            op = numeroOp[i];
            
            //si premiere operation dun job
            if (op % d.nbMach == 0)
            {
                if (head[op] == -1)
                {
                    sol.startDate[op] = 0;
                    sol.head[op] = -1;
                }
                else
                {
                    sol.startDate[op] = sol.startDate[head[op]] + d.time[head[op]];
                    sol.head[op] = head[op];
                }
            }
            //sinon 2 predecesseur
            else
            {
                max = sol.startDate[op-1] +  d.time[op-1];
                sol.head[op] = op-1;
                if ( (head[op] != -1 ) && (sol.startDate[head[op]] + d.time[head[op]]) > max)
                {
                    max = sol.startDate[head[op]] + d.time[head[op]];
                    sol.head[op] = head[op];
                }
                sol.startDate[op] = max;
            }
        }
        //faire le max de toutes les operations
        max = -1;
        for (i = d.nbMach-1 ; i < d.nbOps; i+=d.nbMach)
        {
            if (sol.startDate[i] + d.time[i] > max)
            {
                max = sol.startDate[i] + d.time[i];
                sol.head[d.nbOps] = i;
            }
        }
        sol.makespan = max;
        return sol;
    }
    
    @WebMethod(operationName = "localSearch")
    public Solution localSearch(@WebParam(name = "data") Data d, @WebParam(name = "sol") Solution s, @WebParam(name = "maxIteration") int maxIteration, @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error) 
    {
        Solution sauv = null;
        int 		cpt = 0;
        int 		i = 0; 
        int 		j = 0;
        int		tmp = 0;
        
        if (d==null || s==null)
        {
            return null;
        }
        //précaution
        if (maxIteration > 1000)
        {
            maxIteration = 1000;
            error.value = -1;
        }
        
        //récupérer la position de loperation i dans le vecteur de bierwith pour lechange
        int position[] = new int[d.nbOps];
        int numeroOp[] = new int[d.nbOps];
        int cpt2[] = new int[d.nbJobs];
        
        for (i = 0 ; i < d.nbOps ; i++)
        {
            
            numeroOp[i] = (s.bv.vector[i]-1)*d.nbMach+cpt2[s.bv.vector[i]-1];
            
            cpt2[s.bv.vector[i]-1]++;
            position[numeroOp[i]] = i;
        }
        
        i= d.nbOps;
        j = s.head[i];

        //le dernier arc n'est pas disjonctif donc reculer une fois
        i = j;
        j = s.head[i];

        while( j != -1 && cpt < maxIteration)
        {
                //si les op�rations i et j sont sur la m�me pi�ce (arc conjonctif)
                if(d.job[i] == d.job[j])
                {
                        //on continue � remonter le chemin critique
                        i = j;
                        j = j = s.head[i];
                }
                //sinon on est sur un arc disjonctif
                else
                {
                        //sauvegarder la solution courante
                        sauv = (Solution) s.clone();

                        //inverser 2 �l�ments dans le vecteur de bierwith
                        //tmp = s.getBierwithVector()[s.getPosition()[i]];
                        tmp = s.bv.vector[position[i]];
                        //tmp = s.getBierwithVector()[s.getPosition()[i]];
                        s.bv.vector[position[i]] = s.bv.vector[position[j]];
                        s.bv.vector[position[j]] = tmp;

                        //evaluer le nouveau graphe
                        s = evaluate(d,s.bv);
                        

                        if(s.makespan < sauv.makespan)
                        {
                            i= d.nbOps;
                            j = s.head[i];

                            //le dernier arc n'est pas disjonctif donc reculer une fois
                            i = j;
                            j = s.head[i];
                        }
                        else
                        {
                            //la nouvelle solution n'est pas meilleure ==> repartir de l'ancienne
                            s = null;
                            s = (Solution) sauv.clone();
                            //remonter le chemin critique
                            i = j;
                            j =  s.head[i];
                        }
                }
                cpt++;
        }
        //retourner la solution obtenue avec la RL
        return s;
    }
    
    @WebMethod(operationName = "solutionToSvgFile")
    public byte[] solutionToSvgFile(@WebParam(name = "data") Data d, @WebParam(name = "solution") Solution s) 
    {    
        String uuid = UUID.randomUUID().toString();
        String fichier = "file" + uuid + ".txt" ;
        FileWriter fw = null;
        BufferedWriter output = null;  
        byte[] retour = null;

        
        if (d==null || s==null)
        {
            return null;
        }
        File file = new File(WebServiceJobShop.emplacementFichiers + fichier);
        try
        {
            fw = new FileWriter(file, true);
            output = new BufferedWriter(fw);
        }
        catch(IOException ioe)
        {
            System.out.print("Erreur ouverture fichier en �criture : ");
            ioe.printStackTrace();
        }

        try
        {
            output.write(String.valueOf(d.nbMach) + System.getProperty("line.separator" ));
            output.write(String.valueOf(d.nbJobs)+System.getProperty("line.separator" ));
            output.write(String.valueOf(d.nbOps)+System.getProperty("line.separator" ));
            output.write(String.valueOf(s.makespan)+System.getProperty("line.separator" ));
            String ligne;

            for (int i = 0 ; i < d.nbOps ; i++)
            {
                ligne = String.valueOf(d.mach[i]) + " ";
                ligne += String.valueOf(s.startDate[i]) + " ";
                ligne += String.valueOf(s.startDate[i] + d.time[i])+ " ";
                ligne += String.valueOf(d.job[i]) + " ";//code couleur
                //ligne += "Job-" +  String.valueOf(s.getGraphe().getListe()[i].getNumJob()) + "_Op-" +  String.valueOf(s.getGraphe().getListe()[i].getNumero());
                ligne += "J" +String.valueOf(d.job[i]) + "[" + String.valueOf(s.startDate[i]) + "-" + String.valueOf(s.startDate[i] + d.time[i])  + "]";  
                output.write(ligne+System.getProperty("line.separator" ));
            }
            output.flush();
            output.close();
            fw.close();
        }
        catch(IOException ioe)
        {
            System.out.print("Erreur ajout texte dans fichier de sortie : ");
            ioe.printStackTrace();
        }

        InputStream ips = null;
        try 
        {
            ips = new FileInputStream(file);
            retour = new byte[ips.available()];
            ips.read(retour);
            ips.close();
            retour = txtToSvg(retour, uuid);
            file.delete();
        }
        catch(Exception e)
        {
              
        }
        return retour;
    }
    
    //cette méthode prend un fichier .txt contenant les infos pour retourner un gantt au format svg
    public byte[] txtToSvg(byte[] fichier, String uuid) 
     {
        byte[] b = null;
        File fic = new File(WebServiceJobShop.emplacementFichiers + uuid + ".svg");
        try
        {       
            String ligne;
            String[] tokens;
            int haut = 0, larg = 0;
            int nbMachines = 0;
            int nbJobs = 0;
            //int nbOperations = 0;
            int posx = 0; int posy = 0;
            int rectx = 0;
            int code_couleur = 0;
            int Cmax = 0;
            int numMachine;
            int dateDebut;
            int dateFin; 
            
            FileWriter fw = new FileWriter(fic, true);
            BufferedWriter output = new BufferedWriter(fw);

            //input
            InputStream ips = new ByteArrayInputStream(fichier);
            InputStreamReader ipsr = new InputStreamReader(ips);
            BufferedReader br = new BufferedReader(ipsr);
            // InputStream ips = new FileInputStream(fichierIn);
            //InputStreamReader ipsr = new InputStreamReader(ips);
            //BufferedReader br = new BufferedReader(ipsr);

            //lire le nombre de machine
            ligne = br.readLine();
            nbMachines = Integer.parseInt(ligne);

            ligne = br.readLine();
            nbJobs = Integer.parseInt(ligne);

            ligne = br.readLine();
            //nbOperations = Integer.parseInt(ligne);

            ligne = br.readLine();
            Cmax = Integer.parseInt(ligne);
            haut = 200*nbMachines;
            larg = 150+600*nbJobs;
            output.write("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>"+System.getProperty("line.separator" ))  ;
            output.write( "<svg");
            output.write( " width=\"" + String.valueOf(larg+150) + "\"");
            output.write(" height=\""+ String.valueOf(haut) +"\">"+System.getProperty("line.separator" ));
            //afficher le trait pour indiquer l'origine en x
            output.write("<rect" + System.getProperty("line.separator" ));
            output.write("style=\"fill:#000000;fill-opacity:0.52416353999999998;stroke:#000000;stroke-opacity:1;opacity:0.81372549\""+System.getProperty("line.separator" ));
            output.write("id=\"axeOrigine" + "\"");
            output.write(" width=\""+ String.valueOf(1)+ "\"");
            output.write(" height=\""+ String.valueOf(haut)+ "\"");
            output.write(" x=\""+ String.valueOf(150)+ "\"");
            output.write(" y=\""+ String.valueOf(0)+ "\""+System.getProperty("line.separator" )+"/>"+System.getProperty("line.separator" ));				  


            for (int k = 1 ; k <= nbMachines ; k++)
            {
                    output.write("<text");
                    output.write(" style=\"font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:Bitstream Vera Sans\"");
                    output.write(" x=\"" + String.valueOf(-100 + 150) + "\"");
                    output.write(" y=\"" + String.valueOf(100 + 200*(k-1)) + "\">"+System.getProperty("line.separator" ));
                    output.write("M" + String.valueOf(nbMachines - k + 1) +System.getProperty("line.separator" )+"</text>"+System.getProperty("line.separator" ));
            }

            while ((ligne = br.readLine()) != null)
            {
                tokens = ligne.split(" ");
                numMachine = Integer.parseInt(tokens[0]);
                dateDebut = Integer.parseInt(tokens[1]);
                dateFin = Integer.parseInt(tokens[2]);
                code_couleur = Integer.parseInt(tokens[3]);

                output.write("<rect" + System.getProperty("line.separator" ));
                switch (code_couleur)
                {
                    case 1 : 					  	
                            output.write("style=\"fill:#FF4500;fill-opacity:0.94532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.50457516\""+System.getProperty("line.separator" ));
                        break;
                    case 2 : 						
                            output.write("style=\"fill:#0000FF;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                    break;
                    case 3 : 
                            output.write("style=\"fill:#008000;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                        break;
                    case 4 : 
                            output.write("style=\"fill:#6345b3;fill-opacity:0.85873604000000003;stroke:#000000;stroke-opacity:1;opacity:0.68954248\""+System.getProperty("line.separator" ));
                        break;
                    case 5 : 
                            output.write("style=\"fill:#ffa461;fill-opacity:0.64312267000000001;stroke:#000000;stroke-opacity:1;opacity:0.83333333\""+System.getProperty("line.separator" ));
                        break;
                    case 6 : 
                            output.write("style=\"fill:#800000;fill-opacity:0.54532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                        break;
                    case 7 : 
                            output.write("style=\"fill:#52ff79;fill-opacity:0.75092935999999999;stroke:#000000;stroke-opacity:1;opacity:0.66013072\""+System.getProperty("line.separator" ));
                        break;
                    case 8 : 
                            output.write("style=\"fill:#ff8d2a;fill-opacity:0.71747214;stroke:#000000;stroke-opacity:1;opacity:0.78431373000000004\""+System.getProperty("line.separator" ));
                        break;
                    case 9 : 
                            output.write("style=\"fill:#ffc4ff;fill-opacity:0.86617100000000002;stroke:#000000;stroke-opacity:1;opacity:0.60457516\""+System.getProperty("line.separator" ));
                        break;
                    case 10 : 
                            output.write("style=\"fill:#ffff88;fill-opacity:0.84014869000000003;stroke:#000000;stroke-opacity:1;opacity:0.60130719\""+System.getProperty("line.separator" ));
                        break;
                    case 11 : 
                            output.write("style=\"fill:#a7341f;fill-opacity:0.74532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.90457516\""+System.getProperty("line.separator" ));
                            break;
                    case 12 : 
                            output.write("style=\"fill:#90e041;fill-opacity:0.84532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.60457516\""+System.getProperty("line.separator" ));
                            break;
                    case 13 : 
                            output.write("style=\"fill:#b7ffff;fill-opacity:0.52416353999999998;stroke:#000000;stroke-opacity:1;opacity:0.81372549\""+System.getProperty("line.separator" ));
                            break;
                    case 14 : 
                            output.write("style=\"fill:#908da6;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                            break;
                    case 15 : 
                            output.write("style=\"fill:#108da6;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                            break;
                    case 16 :
                            output.write("style=\"fill:#208ea6;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                            break;
                    case 17 :
                            output.write("style=\"fill:#16220f;fill-opacity:0.78066915;stroke:#000000;stroke-opacity:1;opacity:0.64379085000000003\""+System.getProperty("line.separator" ));
                            break;
                    case 18 :
                            output.write("style=\"fill:#408aa6;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.70457516\""+System.getProperty("line.separator" ));
                            break;
                    case 19 : 
                            output.write("style=\"fill:#5d91b1;fill-opacity:0.63940518999999996;stroke:#000000;stroke-opacity:1;opacity:0.77124183\""+System.getProperty("line.separator" ));
                            break;

                    default :
                            output.write("style=\"fill:#123400;fill-opacity:0.64532124345344533;stroke:#000000;stroke-opacity:1;opacity:0.80457516\""+System.getProperty("line.separator" ));					
                }
                output.write("id=\"rect" + String.valueOf(0) + "\"");
                output.write(" width=\""+ String.valueOf( ((dateFin-dateDebut)/(Cmax*1.0))*larg )+ "\"");
                output.write(" height=\""+ String.valueOf(200)+ "\"");
                output.write(" x=\""+ String.valueOf( (dateDebut/(Cmax*1.0))*larg+150 )+ "\"");
                output.write(" y=\""+ String.valueOf(200*(nbMachines - numMachine))+ "\""+System.getProperty("line.separator" )+"/>"+System.getProperty("line.separator" ));	
                output.write("<text" + System.getProperty("line.separator" ));
                output.write("style=\"font-size:40px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:Bitstream Vera Sans\"" + System.getProperty("line.separator" ));
                rectx = (int) (dateDebut/(Cmax*1.0)*larg);
                posx =  (int) ((rectx + ((dateFin-dateDebut)/(2*Cmax*1.0))*larg)-55)+100;
                posy =  (int) (haut-100)-200*(numMachine-1)+5;
                output.write("x=\"" + String.valueOf(posx) + "\""+System.getProperty("line.separator" ));
                output.write("y=\"" + String.valueOf(posy) + "\">"+System.getProperty("line.separator" ));
                output.write(tokens[4]+"</text>"+System.getProperty("line.separator" ));
            }
            ips.close();
            output.write( "</svg>");
            output.flush();
            output.close();
            br.close();

            fw.close();
            
            InputStream ips2 = new FileInputStream(fic);
            b = new byte[ips2.available()];
            ips2.read(b);
            ips2.close();
            ipsr.close();
            fic.delete();
        }
        catch(IOException ioe)
        {
            System.out.print("Erreur ouverture fichier en écriture : ");
            ioe.printStackTrace();
            fic.delete();
        }
        return b;
    }
    
    
    @WebMethod(operationName = "stop_GRASP")
    public void stop_GRASP(@WebParam(name = "id")String id, @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error,@WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError) 
    {
        
        boolean stop = false;
        int i = 0 , j = 0;
        error.value = -1;
        stringError.value = "Key unknown"; 
        while (!stop && i < NBMAX_CLIENTS)
        {
            j = 0;
            while (!stop && j < NBMAX_FICHIERS)
            {
                if (tableau[i][j] != null && tableau[i][j].occupe == 1 && id.compareTo(tableau[i][j].tag) == 0)
                {
                    if (tableau[i][j].resultat_ready == 1)
                    {
                        error.value = -2;
                        stringError.value = "Grasp already finished"; 
                    }
                    else
                    {
                        tableau[i][j].stop_Grasp = true;
                        error.value = 0;
                        stringError.value = "Grasp stoped"; 
                    }
                    stop = true;
                }   
                ++j;
            }
            ++i;
        }
    }
    
    @WebMethod(operationName = "start_GRASP")
    public String start_GRASP(@WebParam(name = "data") Data d,@WebParam(name = "maxIterLS") int maxIterLS,  @WebParam(name = "ELS") int ELS,@WebParam(name = "neighbourNumber") int nbNeighbour, @WebParam(name = "nbInitialVector") int nbInitialVector,@WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error,@WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError) 
    {
        error.value = -3;
        stringError.value = "The Data is NULL";
        String retour = null;
        if (d!=null)
        {
            int i = 0;
            int j = 0;
            int emplacementDispoClient = 0;
            int emplacementDispoFichier = 0;
            error.value = 0;
            stringError.value = "";
            //int alea = 0;
            //récupérer l'ip du client
            MessageContext mc = wsContext.getMessageContext();
            HttpServletRequest req = (HttpServletRequest)mc.get(MessageContext.SERVLET_REQUEST); 
            String ip_client = req.getRemoteAddr();
            //String ip_client = ipAd;

            //regarder si l'adresse IP du client existe dans ip
            while (i < NBMAX_CLIENTS && ip[i].compareTo(ip_client) != 0)
            {
                ++i;
            }
            //si le client n'existe pas déja
            if (i >= NBMAX_CLIENTS)
            {
                //checher un emplacement disponible
                i = 0;
                while (i < NBMAX_CLIENTS && occupe[i] == 1)
                {
                    ++i;
                }
                //si il n' y a plus d'emplacement disponible pour accueillir le nouveau client
                if (i >= NBMAX_CLIENTS)
                {
                    //chercher un client à supprimer (==> on supprimer un client si toutes ses demandes ont été lancé depuis plus de TPS_DE_VIE_MAX minutes)
                    emplacementDispoClient = suppressionClient();
                    //si emplacementDispo = -1 il n' y a pas de client a supprimer donc pas de places dispo
                    if (emplacementDispoClient == -1)
                    {
                        error.value = -1;
                        stringError.value = "Server is busy, too many clients";
                    } 
                }
                else
                {
                    emplacementDispoClient = i;
                }
                //si on a trouvé un emplacement dispo valide
                if (emplacementDispoClient >= 0 && emplacementDispoClient < NBMAX_CLIENTS)
                {
                    //AJOUTER NOUVEAU CLIENT ET NOUVEAU FICHIER A TRADUIRE
                    emplacementDispoFichier = 0;

                // alea = aleatoire.nextInt(MODULO);
                // retour = emplacementDispoClient*NBMAX_FICHIERS+emplacementDispoFichier*(String.valueOf(alea).length()) + alea;
                    retour = UUID.randomUUID().toString();
                    tableau[emplacementDispoClient][emplacementDispoFichier] = new Fichier();
                    tableau[emplacementDispoClient][emplacementDispoFichier].occupe = 1;
                    tableau[emplacementDispoClient][emplacementDispoFichier].tag = retour;
                    tableau[emplacementDispoClient][emplacementDispoFichier].dateDemande = new Date().getTime();
                    tableau[emplacementDispoClient][emplacementDispoFichier].resultat_ready = 0;
                    tableau[emplacementDispoClient][emplacementDispoFichier].erreur = "";
                    tableau[emplacementDispoClient][emplacementDispoFichier].stop_Grasp = false;
                    ip[emplacementDispoClient] = ip_client;
                    occupe[emplacementDispoClient] = 1;
                    nbFichiers[emplacementDispoClient]++;
                }            
            }
            //sinon le client existe déjà est est situé en i
            else
            {
                //si le client a dépassé le nombre de fichier
                if (nbFichiers[i] >= NBMAX_FICHIERS)
                {
                    //regarder si un fichier n'a pas dépassé la date
                    emplacementDispoFichier = suppressionFichier(i);
                    if (emplacementDispoFichier == -1)
                    {
                        error.value = -2;
                        stringError.value = "Too many Grasps in progress for the same IP";
                    }
                }
                //sinon
                else
                {
                    //rechercher la première place disponible (il y'en a une sur)
                    j = 0;
                    while (j < NBMAX_FICHIERS && tableau[i][j]!=null && tableau[i][j].occupe == 1)
                    {
                        j++;
                    }
                    emplacementDispoFichier = j;                
                }
                if (emplacementDispoFichier >= 0 && emplacementDispoFichier < NBMAX_FICHIERS)
                {
                    //AJOUTER NOUVEAU FICHIER CLIENT i
                    emplacementDispoClient = i;
                    //alea = aleatoire.nextInt(MODULO);
                    //retour = emplacementDispoClient*NBMAX_FICHIERS+emplacementDispoFichier*(String.valueOf(alea).length()) + alea;
                    retour = UUID.randomUUID().toString();
                    tableau[emplacementDispoClient][emplacementDispoFichier] = new Fichier();
                    tableau[emplacementDispoClient][emplacementDispoFichier].tag = retour;
                    tableau[emplacementDispoClient][emplacementDispoFichier].dateDemande = new Date().getTime();
                    tableau[emplacementDispoClient][emplacementDispoFichier].resultat_ready = 0;
                    tableau[emplacementDispoClient][emplacementDispoFichier].erreur = "";
                    tableau[emplacementDispoClient][emplacementDispoFichier].occupe = 1;
                    tableau[emplacementDispoClient][emplacementDispoFichier].stop_Grasp = false;
                    //ip[emplacementDispoClient] = ip_client;
                    //dispo[emplacementDispoClient] = 1;
                    nbFichiers[emplacementDispoClient]++;
                }

            }
            //si pas d'erreur
            if (error.value >= 0)
            {
                //Instancier la classe Method qui implémente Runnable
                MethodGrasp m  = new MethodGrasp(d,  maxIterLS,  ELS,  nbNeighbour,  nbInitialVector,emplacementDispoClient, emplacementDispoFichier, retour);
                //Créer un thread chargé de faire le boulot
                Thread t = new Thread(m);
                //Lancer le thread
                t.start();
            }
        }
        
        
        return retour;
    }
    

    @WebMethod(operationName = "isCompleteThread_GRASP")
    public int isCompleteThread_GRASP(@WebParam(name = "id") String id, @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error, @WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError) 
    {
       int ret = -1;
       int i = 0 , j = 0 ;
       boolean stop = false;
       
       stringError.value = "Key unknown";
       error.value = -1;
       ret = -1;
       while (id!=null && !stop && i < NBMAX_CLIENTS)
       {
           j = 0;
           while (!stop && j < NBMAX_FICHIERS)
           {
               if (tableau[i][j]!=null && tableau[i][j].occupe == 1 && id.compareTo(tableau[i][j].tag) == 0)
               {
                   ret = 0; 
                   error.value = 0;
                   stringError.value = "Execution still in progress";
                   if (tableau[i][j].resultat_ready == 1)
                   {
                       ret = 1; 
                       error.value = 0;
                       stringError.value = "Best solution available";
                   } 
                   stop = true;
               }
               ++j;
           }
           ++i;
       }
       return ret;  
    }
    
    @WebMethod(operationName = "readResult_GRASP")
    public Solution readResult_GRASP(@WebParam (name = "id") String id,  @WebParam(name = "error", mode = WebParam.Mode.INOUT) Holder<Integer> error, @WebParam(name = "stringError", mode = WebParam.Mode.INOUT) Holder<String> stringError ) 
    {
        Solution retour = null;
        boolean stop = false;
        int i = 0 , j = 0;
        error.value = -1;
        stringError.value = "Key unknown"; 
        while (id != null && !stop && i < NBMAX_CLIENTS)
        {
            j = 0;
            while (!stop && j < NBMAX_FICHIERS)
            {
                if (tableau[i][j] != null && tableau[i][j].occupe == 1 && id.compareTo(tableau[i][j].tag) == 0)
                {
                    //resultat dispo
                    if (tableau[i][j].resultat_ready == 1)
                    {
                        //si le thread a généré une erreur lors de la conversion
                        if (tableau[i][j].erreur.compareTo("OK") != 0)
                        {
                            error.value = -3;
                            stringError.value = "Error during grasp :" + tableau[i][j].erreur; 
                        }
                        else //sinon
                        {
                            error.value = 0;
                            stringError.value = "Execution ok"; 
                            retour = (Solution) tableau[i][j].bestSol.clone();
                        }
                        //mettre à jour les infos
                        //si le client n'avait qu'un fichier virer le client
                        if (nbFichiers[i] == 1)
                        {
                            tableau[i][j].occupe = 0;
                            tableau[i][j].resultat_ready = 0;
                            tableau[i][j].bestSol = null;
                            tableau[i][j].stop_Grasp = false;
                            occupe[i] = 0;
                            nbFichiers[i] = 0;
                            ip[i] = " ";
                            
                        }
                        //sinon enlever que le fichier
                        else
                        {
                            tableau[i][j].occupe = 0;
                            nbFichiers[i]--;
                            tableau[i][j].resultat_ready = 0;
                            tableau[i][j].bestSol = null;
                            tableau[i][j].stop_Grasp = false;
                        }
                    }
                    else //resultat pas dispo
                    {
                        error.value = -2;
                        stringError.value = "Execution still in progress";
                    }
                    stop = true;
                    
                }   
                ++j;
            }
            ++i;
        }
        
        return retour;
    }
    
    
    class MethodGrasp implements Runnable
    {
        private Data d;
        private int maxIterLS;
        private int ELS;
        private int nbNeighbour;
        private int nbInitialVector;

        private int i;
        private int j;
        private String id_client;

        public MethodGrasp(Data d, int maxIterLS, int ELS, int nbNeighbour, int nbInitialVector, int i, int j, String id_client)
        {
            this.d = (Data) d.clone();
            this.maxIterLS = maxIterLS;
            this.ELS = ELS;
            this.nbNeighbour = nbNeighbour;
            this.nbInitialVector = nbInitialVector;

            this.id_client = id_client;
            this.i = i;
            this.j = j;
        }

        @Override
        public void run() 
        {
        WebServiceJobShop.tableau[this.i][this.j].erreur = "OK";
        Solution sBestGlobal = null;
        Solution sBestEls = null;
        Solution sBestVoisin = null;
        Solution sVoisin = null; //solution voisin courant
        BierwithVector bVoisin = null;
        Solution s = null; //solution S de d�part

        int iterMax = 500;
        int cpt = 0;

        boolean optimumAtteint = false;
        //boolean bestEvolue = false;
        int i, j, k = 0;

        sBestGlobal = evaluate(d, getRandomBierwithVector(d, -1));

        Holder<Integer> error = null;
        for (i = 0 ; i < this.nbInitialVector && !tableau[this.i][this.j].stop_Grasp  && !optimumAtteint ; i++)
        {
                s = evaluate(d, getRandomBierwithVector(d, -1));
                //faire une recherche locale sur s
                s = localSearch(d,s,this.maxIterLS,error);

            if (s.makespan < sBestGlobal.makespan)
            {
                    sBestGlobal = (Solution) s.clone();
                    //dEndDate = new Date();
                    //sBestGlobal.setTemps(dEndDate.getTime() - dStartDate.getTime());
            }

            sBestEls = (Solution) s.clone();		
            for (j = 0 ; j < this.ELS && !tableau[this.i][this.j].stop_Grasp && !optimumAtteint ; j++)
            {
                    sBestVoisin = (Solution) sBestEls.clone();
                    sBestVoisin.makespan = 999999;
                    k = 0;

                    do 
                    {
                            //G�n�rer un voisin de Sbestels.
                            bVoisin = getNeighbourBierwithVector(sBestEls.bv);

                            sVoisin = evaluate(d, bVoisin);
                            sVoisin = localSearch(d, sVoisin, maxIterLS, error);
                            //faire une recherche locale sur ce voisin
                            //sVoisin.evaluer();
                            if (sVoisin.makespan < sBestVoisin.makespan)
                            {
                                sBestVoisin = (Solution) sVoisin.clone();
                            }
                            k++;
                            cpt++;
                    }while (k<this.nbNeighbour && cpt < iterMax && !tableau[this.i][this.j].stop_Grasp && !optimumAtteint );



                    if (sBestVoisin.makespan < sBestGlobal.makespan)
                    {
                            sBestGlobal = (Solution) sBestVoisin.clone();
                            if (sBestGlobal.makespan <= d.lowerBound)
                            {
                                optimumAtteint = true;
                            }
                    }

                    sBestEls = (Solution) sBestVoisin.clone();  

            }
        }
        WebServiceJobShop.tableau[this.i][this.j].resultat_ready = 1;
        WebServiceJobShop.tableau[this.i][this.j].bestSol = (Solution) sBestGlobal.clone();


        }
    }
}

